/******************************************************************************
版权所有：	
文件名称：	base64.c
文件版本：	01.01
创建作者：	sunxi
创建日期：	2015-07-04
功能说明：	base64解码实现文件.	
								
其它说明：
修改记录：
*/
#include "head.h"
#include "x509.h" 
#include "base64.h"

#ifdef LINUX_KERNEL_APP
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/fs.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/kthread.h>
#include <linux/delay.h>
#include <linux/wait.h> 
#include <asm/uaccess.h>
#include <asm/io.h>
#include <asm/ioctls.h>
#include <linux/syscalls.h> 
#include <termios.h>
#else
#include <linux/fs.h>
#include <linux/sched.h>
#include <linux/wait.h> 
#include <termios.h>
#endif 


enum {
	BASE64_FLAG_UU_STOP = 0x100,
	/* Sign-extends to a value which never matches fgetc result: */
	BASE64_FLAG_NO_STOP_CHAR = 0x80,
};



/* Conversion table.  for base 64 */
static const char bb_uuenc_tbl_base64[65 + 1] = {
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
	'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
	'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
	'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
	'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
	'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
	'w', 'x', 'y', 'z', '0', '1', '2', '3',
	'4', '5', '6', '7', '8', '9', '+', '/',
	'=' /* termination character */,
	'\0' /* needed for uudecode.c only */
};


/*
 * Encode bytes at S of length LENGTH to uuencode or base64 format and place it
 * to STORE.  STORE will be 0-terminated, and must point to a writable
 * buffer of at least 1+BASE64_LENGTH(length) bytes.
 * where BASE64_LENGTH(len) = (4 * ((LENGTH + 2) / 3))
 */
void bb_uuencode(char *p, const void *src, int length, const char *tbl)
{
	const unsigned char *s = src;

	/* Transform the 3x8 bits to 4x6 bits */
	while (length > 0) {
		unsigned s1, s2;

		/* Are s[1], s[2] valid or should be assumed 0? */
		s1 = s2 = 0;
		length -= 3; /* can be >=0, -1, -2 */
		if (length >= -1) {
			s1 = s[1];
			if (length >= 0)
				s2 = s[2];
		}
		*p++ = tbl[s[0] >> 2];
		*p++ = tbl[((s[0] & 3) << 4) + (s1 >> 4)];
		*p++ = tbl[((s1 & 0xf) << 2) + (s2 >> 6)];
		*p++ = tbl[s2 & 0x3f];
		s += 3;
	}
	/* Zero-terminate */
	*p = '\0';
	/* If length is -2 or -1, pad last char or two */
	while (length) {
		*--p = tbl[64];
		length++;
	}
}

void encode_base64(char *p, const void *src, int length)
{
	bb_uuencode(p,src,length,bb_uuenc_tbl_base64);
}



/*
 * Decode base64 encoded string. Stops on '\0'.
 *
 * Returns: pointer to the undecoded part of source.
 * If points to '\0', then the source was fully decoded.
 * (*pp_dst): advanced past the last written byte.
 */
const char*  decode_base64(char **pp_dst, const char *src)
{
	char *dst = *pp_dst;
	const char *src_tail;

	while (1) {
		unsigned char six_bit[4];
		int count = 0;

		/* Fetch up to four 6-bit values */
		src_tail = src;
		while (count < 4) {
			char *table_ptr;
			int ch;

			/* Get next _valid_ character.
			 * bb_uuenc_tbl_base64[] contains this string:
			 *  0         1         2         3         4         5         6
			 *  01234567890123456789012345678901234567890123456789012345678901234
			 * "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="
			 */
			do {
				ch = *src;
				if (ch == '\0') {
					if (count == 0) {
						/* Example:
						 * If we decode "QUJD <NUL>", we want
						 * to return ptr to NUL, not to ' ',
						 * because we did fully decode
						 * the string (to "ABC").
						 */
						src_tail = src;
					}
					goto ret;
				}
				src++;
				table_ptr = strchr(bb_uuenc_tbl_base64, ch);
//todo: add BASE64_FLAG_foo to die on bad char?
			} while (!table_ptr);

			/* Convert encoded character to decimal */
			ch = table_ptr - bb_uuenc_tbl_base64;

			/* ch is 64 if char was '=', otherwise 0..63 */
			if (ch == 64)
				break;
			six_bit[count] = ch;
			count++;
		}

		/* Transform 6-bit values to 8-bit ones.
		 * count can be < 4 when we decode the tail:
		 * "eQ==" -> "y", not "y NUL NUL".
		 * Note that (count > 1) is always true,
		 * "x===" encoding is not valid:
		 * even a single zero byte encodes as "AA==".
		 * However, with current logic we come here with count == 1
		 * when we decode "==" tail.
		 */
		if (count > 1)
			*dst++ = six_bit[0] << 2 | six_bit[1] >> 4;
		if (count > 2)
			*dst++ = six_bit[1] << 4 | six_bit[2] >> 2;
		if (count > 3)
			*dst++ = six_bit[2] << 6 | six_bit[3];
		/* Note that if we decode "AA==" and ate first '=',
		 * we just decoded one char (count == 2) and now we'll
		 * do the loop once more to decode second '='.
		 */
	} /* while (1) */
 ret:
	*pp_dst = dst;
	return src_tail;
}


static void read_base64(int src_stream, int dst_stream, int flags)
{
/* Note that EOF _can_ be passed as exit_char too */
#define exit_char    ((int)(signed char)flags)
#define uu_style_end (flags & BASE64_FLAG_UU_STOP)

	/* uuencoded files have 61 byte lines. Use 64 byte buffer
	 * to process line at a time.
	 */
	enum { BUFFER_SIZE = 64 };

	char in_buf[BUFFER_SIZE + 2];
	char out_buf[BUFFER_SIZE / 4 * 3 + 2];
	char *out_tail;
	const char *in_tail;
	int term_seen = 0;
	int in_count = 0;
	char ch = 0;
	int ret = 0;

	while (1) {
		while (in_count < BUFFER_SIZE) {
			ret = sys_read(src_stream, &ch, 1);
			if (ret != 1) {
				if (in_count == 0)
					return;
				term_seen = 1;
				break;
			}
			if (ret != 1) {
				term_seen = 1;
				break;
			}
			/* Prevent "====" line to be split: stop if we see '\n'.
			 * We can also skip other whitespace and skirt the problem
			 * of files with NULs by stopping on any control char or space:
			 */
			if (ch <= ' ')
				break;
			in_buf[in_count++] = ch;
		}
		in_buf[in_count] = '\0';

		/* Did we encounter "====" line? */
		if (uu_style_end && strcmp(in_buf, "====") == 0)
			return;

		out_tail = out_buf;
		in_tail = decode_base64(&out_tail, in_buf);

		//fwrite(out_buf, (out_tail - out_buf), 1, dst_stream);
		sys_write(dst_stream, out_buf, (out_tail - out_buf));

		if (term_seen) {
			/* Did we consume ALL characters? */
			if (*in_tail == '\0')
				return;
			/* No */
			//bb_error_msg_and_die("truncated base64 input");
			rt_printf("truncated base64 input");
			return;
		}

		/* It was partial decode */
		in_count = strlen(in_tail);
		memmove(in_buf, in_tail, in_count);
	}
}

int  base64file_to_binfile(char * base64file,  char *binfile)
{
	int fd_src;
	int fd_dst;
	char *file_data;
	struct stat s;
	int ret = 0;
	int len_begin = strlen(BEGIN_CERTIFICATE);
	char *p_begin;
	char *p_end;
	
	//获取文件属性
	if(sys_newstat(base64file, &s))
	{
		rt_printf("%s:sys_newstat error\n",__func__);
		return -1;
	}	

	//分配内存
	file_data = rt_malloc(s.st_size+1);
	
	if(!file_data)
	{
		rt_printf("%s:rt_malloc error\n",__func__);
		return -1;	
	}		
	
	//打开文件
	fd_src = sys_open(base64file, O_RDONLY, 0);	
	
	if(fd_src < 0)
	{
		rt_printf("%s:sys_open %s error\n",__func__ , base64file);
		rt_free(file_data);
		return -1;
	}	
	
	//读取整个文件内容
	ret = sys_read(fd_src, file_data, s.st_size);
	
	if(ret!=s.st_size)
	{
		rt_printf("%s:sys_read error\n",__func__);
		sys_close(fd_src);
		rt_free(file_data);
		return -1;	
	}
	
	//最后一个字节补0
	file_data[s.st_size]=0;
	//关闭文件
	sys_close(fd_src);
	
	//查找base64编码的开始字符串
	p_begin=strstr(file_data, BEGIN_CERTIFICATE);
	//查找base64编码的结束字符串
	p_end=strstr(file_data, END_CERTIFICATE);	
	
	
	//找到开始标示和结束标示,说明是base64编码格式.需要将开始和结束标示处理掉
	if(p_begin && p_end)
	{
		//创建临时文件
		fd_src = sys_open(FILENAME_X509_TMP, O_CREAT|O_RDWR | O_TRUNC|O_SYNC, 0777);	
		if(fd_src < 0)
		{
			rt_printf("%s:creat file %s error\n",__func__, FILENAME_X509_TMP);
			rt_free(file_data);
			return  -1;
		}			
		
		//base64编码的开始字符
		p_begin	=&p_begin[len_begin];
						
		//将base64编码内容写到临时文件中，便于解码
		sys_write(fd_src, p_begin, (p_end - p_begin ));		
		//关闭临时文件
		sys_close(fd_src);

		
		//临时文件创建成功后，再以只读方式打开	
		fd_src = sys_open(FILENAME_X509_TMP, O_RDONLY, 0);	
		
		if(fd_src < 0)
		{
			rt_printf("%s:sys_open %s error\n",__func__ , FILENAME_X509_TMP);
			rt_free(file_data);
			return -1;
		}
		
		//创建解码临时文件
		fd_dst=sys_open(binfile, O_CREAT|O_RDWR | O_TRUNC|O_SYNC, 0777);	
				
		if(fd_dst < 0)
		{
			rt_printf("%s:creat file %s error\n",__func__, binfile);
			sys_close(fd_src);
			return -1;
		}	
		//解码
		read_base64(fd_src, fd_dst, (char)-1);	
		
		//关闭文件
		sys_close(fd_dst);
		sys_close(fd_src);			
				
	}
	else 
	{
		//如果是二进制文件，直接拷贝
		rt_file_cp(base64file,  binfile);
	}
	
	//释放内存
	rt_free(file_data);

	return  0;
}
